﻿Type=Activity
Version=2.52
@EndOfDesignText@
#Region Copyright
	'******************************************************************************
	' This File is part of B4A Project ropMemo
	'                                                                              
	' Copyright (c) 2013 Robert W.B. Linn, Pinneberg, Germany                      
	'                                                                              
	' This Is free software: you can redistribute it AND/OR modify it under        
	' the terms of the GNU General Public License As published by the Free Software
	' Foundation, either version 3 of the License, OR (at your option) any later   
	' version. This application Is distributed WITHOUT ANY WARRANTY; without even  
	' the implied warranty of MERCHANTABILITY OR FITNESS For A PARTICULAR PURPOSE. 
	' See the GNU General Public License For more details.                         
	' You should have received a copy of the GNU General Public License along with 
	' this application. If Not, www.gnu.org/licenses/.                             
	'                                                                              
	' Author: Robert W.B. Linn, Pinneberg, Germany                                 
	' Internet, E-Mail: www.rwblinn.de , robert@rwblinn.de                         
	' Read readme.txt For latest information                                       
	'                                                                              
	'******************************************************************************
#End Region

#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	' database fields
	Dim edSubject As EditText
	Dim lblDate As Label
	Dim edMemo As EditText

	' Toolbar 
	Dim pnlToolbar As Panel
	Dim btnClose As Button
	Dim btnSave As Button
	Dim btnDiscard As Button
	Dim btnDelete As Button
	Dim btnMail As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("manage")
	DateTime.DateFormat = "dd.MM.yyyy"

	' make adjustments to the views - start at the top
	' Memo
	edMemo.Height = Activity.Height - edSubject.Height - lblDate.Height - pnlToolbar.Height

	' Panel Toolbar at the bottom	
	pnlToolbar.Top = Activity.Height - pnlToolbar.Height
	btnClose.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_menu_home.png"))
	btnSave.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_menu_save.png"))
	btnDiscard.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_menu_discard.png"))
	btnDelete.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_menu_delete.png"))
	btnMail.SetBackgroundImage(LoadBitmap(File.DirAssets, "ic_menu_mail.png"))

	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: MemoID = " & Main.MemoID)
	' Select Memo to edit - If MemoID = -1 then a new Memo can be build
	' memo create
	If Main.MemoID = -1 Then
        Activity.Title	= "Neues Memo"
		lblDate.Text 	= DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	End If
	' memo edit
	If Main.MemoID <> -1 Then
		' Get the Memo from the database
		Dim Cursor1 As Cursor
		' Query should only reurn 1 row
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: SELECT * FROM Memos WHERE ID=" & Main.MemoID)
		Cursor1 = Main.SQL1.ExecQuery("SELECT ID, Subject, Date, Memo FROM Memos WHERE ID=" & Main.MemoID)
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Row Found = " & Cursor1.RowCount)
    	For i = 0 To Cursor1.RowCount - 1
        	Cursor1.Position = i
        	Activity.Title	= "MemoID: " & Cursor1.GetInt("ID")
			edSubject.Text	= Cursor1.GetString("Subject")
			lblDate.Text 	= Cursor1.GetString("Date")
			edMemo.Text 	= Cursor1.GetString("Memo")
			Next
	    Cursor1.Close	
	End If
	edSubject.RequestFocus
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnClose_Click
' Close 
	Activity.Finish
End Sub

Sub btnSave_Click
' Save the Memo to the sqlite database
	Dim SQLCmd As String
	Dim Cnt As Int
	' Build the sql insert or update command
	' Insert new triggered by a memoid of -1
	If Main.MemoID = -1 Then
		' Lets check if memo already exists - in case inform via msgbox and exit
		Dim Cursor1 As Cursor
		SQLCmd = "SELECT ID FROM Memos WHERE Subject='" & edSubject.Text & "'"
		Cursor1 = Main.SQL1.ExecQuery(SQLCmd)
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Row Found = " & Cursor1.RowCount)
		Cnt = Cursor1.RowCount 
		Cursor1.Close	
		' Entry found
		If Cnt = 1 Then
			Log("(manage)" & DateTime.Date(DateTime.Now) & " :: Memo ist schon vorhanden")
			Msgbox(Main.CERRMEMOEXISTS & Main.CCRLF2 & edSubject.Text, Main.CHDGSAVEMEMO)
			Return
		End If
		'	
		SQLCmd = "INSERT INTO Memos (ID, Subject, Date, Memo) VALUES (NULL, '" _
				 & edSubject.Text & "', '" _
				 & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & "', '" _
				 & edMemo.Text & "')"
	End If
	' Update memo triggered by memid <> -1
	If Main.MemoID <> -1 Then
		SQLCmd = "UPDATE Memos Set " _
				 & "Subject='" & edSubject.Text & "', " _
				 & "Date='" & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & "', " _
				 & "Memo='" & edMemo.Text & "' " _
				 & "WHERE ID=" & Main.MemoID
	End If
	' Run sql non query command
	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Save = " & SQLCmd)
	Main.SQL1.BeginTransaction
	Try
		Main.SQL1.ExecNonQuery(SQLCmd)
		Main.SQL1.TransactionSuccessful 
	Catch 
		' Exception = no changes will be made
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Exception: " & LastException.Message) 
		Msgbox(LastException.Message, Main.CHDGERROR)
	End Try 
	Main.SQL1.EndTransaction
	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: SQL nonquery completed")
	Activity.Finish
End Sub

Sub btnDiscard_Click
' Close this activity without saving any changes or new memo
	Activity.Finish
End Sub

Sub btnDelete_Click
' Delete Memo
	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: delete_click")
	Dim SQLCmd As String

	' Check memo - this acion should not be needed, but wanna go for sure; and also show how to select memo by subject
	If Main.MemoID = -1 Then
		Dim Cursor1 As Cursor
		' Query should only return 1 row
		Cursor1 = Main.SQL1.ExecQuery("SELECT ID FROM Memos WHERE Subject='" & Main.MemoSubject & "'")
		Log("(manage)" & DateTime.Date(DateTime.Now) & " :: Row Found = " & Cursor1.RowCount)
		If Cursor1.RowCount = 1 Then
    	    Cursor1.Position = 0
        	Main.MemoID = Cursor1.GetInt("ID")
		End If
    	Cursor1.Close
	End If
	' if memoid still is -1 (maens subject could not be found), then do nothing
	If Main.MemoID = -1 Then
		Return
	End If

	' lets ask the user for confirmation; if NO then exit
	If Msgbox2(Main.CASKDELMEMO & Main.CCRLF2 & Main.MemoSubject, Main.CHDGDELMEMO , Main.CASKYES, "", Main.CASKNO, Null) = DialogResponse.NEGATIVE Then
    	Return False
	End If

	' Delete confirmed
	' Build the sql delete command
	If Main.MemoID <> -1 Then
		SQLCmd = "DELETE FROM Memos WHERE ID=" & Main.MemoID
	End If
	' Run sql command
	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Delete = " & SQLCmd)
	Main.SQL1.BeginTransaction
	Try
		Main.SQL1.ExecNonQuery(SQLCmd)
		Main.SQL1.TransactionSuccessful 
	Catch 
		' Exception = no changes will be made
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: Exception: " & LastException.Message) 
		Msgbox(LastException.Message, Main.CHDGERROR)
	End Try 
	Main.SQL1.EndTransaction
	Log("(manage)" & DateTime.Time(DateTime.Now) & " :: delete completed")
	Activity.Finish
End Sub

Sub btnMail_Click
' Send memo as email using standard 	
	Dim Message As Email

	' Prepare = check at least if subject has some text
	If edSubject.Text = "" Then
		Msgbox(Main.CERRNOSUBJECT, Main.CHDGERROR)
		Return
	End If

	' Define the message
	' 
	Message.To.Add("email@adress.com")
	Message.Subject = edSubject.Text
	Message.Body = edMemo.Text
	'Message.Attachments.Add(File.Combine(File.DirRootExternal, "myfile.txt"))
	
	' Lets go
	Try
		StartActivity(Message.GetIntent) 
	Catch
		Log("(manage)" & DateTime.Time(DateTime.Now) & " :: EMail Exception: " & LastException.Message) 
		Msgbox(LastException.Message, Main.CHDGERROR)
	End Try
End Sub

